<script lang="ts" setup>
import { ref, onMounted, watch } from "vue";
import Chart from "chart.js/auto";
import { useUtilityStore } from "../../stores/utilitycost/utilitycost";
import { useBranchStore } from "@/stores/branch";
import { useAuthStore } from "@/stores/auth";
import utilityCostService from "@/services/utilityCost";
import html2pdf from "html2pdf.js";

const branchStore = useBranchStore();
const authStore = useAuthStore();
const ucStore = useUtilityStore();
const branches = ref<string[]>([]);
const items = ref<{ month: string; price: number }[]>([]);
const total_price = ref(0);
const myChart = ref<any>(null);
const years = ref<any[]>([]);
const thaiMonths = [
  "มกราคม",
  "กุมภาพันธ์",
  "มีนาคม",
  "เมษายน",
  "พฤษภาคม",
  "มิถุนายน",
  "กรกฎาคม",
  "สิงหาคม",
  "กันยายน",
  "ตุลาคม",
  "พฤศจิกายน",
  "ธันวาคม",
];

async function setBranches() {
  await branchStore.getBranches();
  const branchSet = new Set(branchStore.branches.map((branch) => branch.name));
  if (authStore.getCurrentUser()!.role.name === "เจ้าของกิจการ") {
    branches.value = ["all", ...Array.from(branchSet)];
  } else if (authStore.getCurrentUser()!.role.name === "ผู้จัดการร้าน") {
    branches.value = [authStore.getCurrentUser()!.branch.name];
  }
}

async function setYears() {
  const res = await utilityCostService.getYear();
  years.value = res.data.map((year: any) => year.Y_NUMBER);
}

async function updateChartData() {
  total_price.value = 0;
  const dataDB = await utilityCostService.getPriceOfAllMonth(
    ucStore.year,
    ucStore.branch
  );
  console.log(dataDB.data);
  const months: string[] = [];
  const prices: number[] = [];
  const itemsArray: { month: string; price: number }[] = [];
  if (Array.isArray(dataDB.data)) {
    for (const db of dataDB.data) {
      months.push(thaiMonths[db.M_NUMBER - 1]);
      prices.push(db.Total_Price);
      total_price.value += Number(db.Total_Price);
      itemsArray.push({ month: thaiMonths[db.M_NUMBER - 1], price: db.Total_Price });
    }
    items.value = itemsArray;
    console.log(items);
  } else {
    console.log("no data");
  }

  if (myChart.value) {
    myChart.value.destroy();
  }

  const data = {
    labels: months,
    datasets: [
      {
        barPercentage: 10,
        barThickness: 50,
        maxBarThickness: 50,
        minBarLength: 50,
        label: "ค่าใช้จ่าย",
        data: prices,
      },
    ],
  };

  const config = {
    type: "bar",
    data: data,
    options: {
      responsive: true,
      plugins: {
        legend: {
          position: "top",
        },
        title: {
          display: true,
          text: "ค่าใช้จ่ายสาธุณูปโภคประจําปี " + ucStore.year,
        },
      },
    },
  };

  const ctx = document.getElementById("myChart");
  if (ctx) {
    myChart.value = new Chart(ctx, config);
  }
}

onMounted(async () => {
  await setBranches();
  await setYears();
  getCurrentData();
  await updateChartData();
});

async function printToPdf() {
  const element = document.getElementById("printableContent");
  if (element) {
    const options = {
      margin: 1,
      filename: "report.pdf",
      image: { type: "jpeg", quality: 0.98 },
      html2canvas: { scale: 2 },
      jsPDF: { unit: "in", format: "letter", orientation: "portrait" },
    };

    html2pdf().set(options).from(element).save();
  }
}

function getCurrentData() {
  const currentDate = new Date();
  ucStore.year = currentDate.getFullYear();
  const numMonth = currentDate.getMonth() + 1;
  ucStore.month = {
    id: numMonth,
    name: thaiMonths[numMonth - 1],
  };
  ucStore.branch = authStore.getCurrentUser()?.branch.name;
}
</script>
<template>
  <v-sheet border class="text-center mx-auto">
    <div id="printableContent">
      <v-row style="margin-top: 20px" class="d-flex justify-center">
        สาขา : {{ ucStore.branch }} ประจําปี : {{ ucStore.year }}
      </v-row>
      <v-container>
        <v-col cols="12">
          <v-row>
            <v-col cols="12" class="d-flex justify-center">
              <div style="height: 500px; width: 900px">
                <canvas id="myChart"></canvas>
              </div>
            </v-col>
            <v-col cols="12" max-width="100%">
              <v-card>
                <v-card-title class="text-center" style="font-size: 16"
                  >รายการค่าใช้จ่าย รวม {{ total_price }} บาท
                </v-card-title>
                <v-card-text>
                  <v-table fixed-header style="height: 295px; overflow-y: auto">
                    <thead>
                      <tr>
                        <th class="text-left">ประเภท</th>
                        <th class="text-left">ราคา</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr v-for="(item, index) in items" :key="index">
                        <td>{{ item.month }}</td>
                        <td>{{ item.price }}</td>
                      </tr>
                    </tbody>
                  </v-table>
                </v-card-text>
              </v-card>
            </v-col>
          </v-row>
        </v-col>
      </v-container>
    </div>
    <v-col cols="12">
      <v-card>
        <v-card-text>
          <v-row padding="px-4" style="margin-top: 10px; margin-bottom: 20px">
            <v-col cols="12" md="6">
              <v-combobox
                v-model="ucStore.branch"
                label="สาขา"
                variant="outlined"
                :items="branches"
              ></v-combobox>
            </v-col>
            <v-col cols="12" md="3">
              <v-combobox
                v-model="ucStore.year"
                label="ปี"
                variant="outlined"
                :items="years"
              ></v-combobox>
            </v-col>
            <v-col cols="12" md="3">
            <v-col class="d-flex justify-center">
                <v-btn color="blue-darken-1" variant="text" @click="updateChartData()"
                  >update</v-btn
                >
              </v-col>
            </v-col>
              
            </v-row>
        </v-card-text>
      </v-card>
    </v-col>

    <v-btn color="blue-darken-1" variant="text" @click="printToPdf()">Print to PDF</v-btn>
  </v-sheet>
</template>
